/* vm.h   by Michael Thorpe   2010-07-09 */

#ifndef VM_H
#define VM_H

#define OP_NOT      '!'
#define OP_NEEDARGS '#'
#define OP_BITSEL   '%'
#define OP_AND      '&'
#define OP_QUOTE    '\''
#define OP_MUL      '*'
#define OP_ADD      '+'
#define OP_UNQUOTE  ','
#define OP_SUB      '-'
#define OP_DIV      '/'
#define OP_NIL      '0'
#define OP_EXTYPE   '1'
#define OP_EXVALUE  '2'
#define OP_THROW    ':'
#define OP_EQ       '='
#define OP_ASR      '>'
#define OP_CMP      '?'
#define OP_DEFINE   'A'
#define OP_CALL     'C'
#define OP_POP      'D'
#define OP_BF       'F'
#define OP_GOTO     'G'
#define OP_INDEX    'I'
#define OP_LOCALOBJ 'L'
#define OP_OBJTYPE  'O'
#define OP_PUT      'P'
#define OP_RET      'R'
#define OP_SET      'S'
#define OP_BT       'T'
#define OP_UNDEFINE 'U'
#define OP_EXCH     'X'
#define OP_CAR      'a'
#define OP_CONS     'c'
#define OP_CDR      'd'
#define OP_PUSHI    'i'
#define OP_LOOKUP   'l'
#define OP_PAIR     'p'
#define OP_RETCALL  'r'
#define OP_CATCH    '{'
#define OP_OR       '|'
#define OP_TOSS     '}'

#endif
